//============================================================================
// Name        : dlTest.cpp
// Author      : nick
// Version     :
// Copyright   : Your copyright notice
// Description : Hello World in C++, Ansi-style
//============================================================================

/*
 #include <iostream>
 #include <dlfcn.h>

 using namespace std;

 typedef int(*MainFuncType)();

 extern "C" int foo()
 {
 cout << "this is foo" << endl;
 return 0;
 }

 int main()
 {
 void* pFun = dlopen("/home/nick/MyProjects/dlTest/Debug/dlTest.backup", RTLD_LAZY);
 dlerror();
 if (pFun)
 {
 char* pError= NULL;
 dlerror();
 MainFuncType pFoo = (MainFuncType)dlsym(pFun, "foo");
 pError = dlerror();
 if (pError)
 {
 cout << "error:" << pError << endl;
 }
 else
 {
 cout << "prepare recursive call" << endl;
 (*pFoo)();
 }
 dlclose(pFun);
 }
 else
 {
 cout << " cannot open executable :" << dlerror() << endl;
 }
 return 0;
 }
 *
 *
 */

/*
 //#define _GNU_SOURCE
 #include <link.h>
 #include <stdlib.h>
 #include <stdio.h>

 static int
 callback(struct dl_phdr_info *info, size_t size, void *data)
 {
 int j;

 printf("name=%s (%d segments)\n", info->dlpi_name,
 info->dlpi_phnum);

 for (j = 0; j < info->dlpi_phnum; j++)
 printf("\t\t header %2d: address=%10p\n", j,
 (void *) (info->dlpi_addr + info->dlpi_phdr[j].p_vaddr));
 return 0;
 }

 int
 main(int argc, char *argv[])
 {
 dl_iterate_phdr(callback, NULL);

 exit(EXIT_SUCCESS);
 }
 */

/* libmfilter.c */


#include <stdio.h>
#include <assert.h>
#include <dlfcn.h>

typedef void * (*malloc_t) (size_t nbytes);

void * malloc (size_t nbytes)
{
    void *r;
    static malloc_t real_malloc = 0;
    if (!real_malloc)
    {
        real_malloc = (malloc_t) dlsym(RTLD_NEXT, "malloc");
        assert(real_malloc);
    }
    r = (*real_malloc) (nbytes);
    printf("malloc %zu bytes at %p\n", nbytes, r);

    return r;
}

typedef void(*free_t)(void* ptr);
void free(void* ptr)
{
    static free_t real_free = 0;
    if (real_free == 0)
    {
        real_free = (free_t)dlsym(RTLD_NEXT, "free");
        assert(real_free);
    }
    printf("free %p\n", ptr);
    (*real_free)(ptr);
}


